'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _beeButton = require('bee-button');

var _beeButton2 = _interopRequireDefault(_beeButton);

var _beeModal = require('bee-modal');

var _beeModal2 = _interopRequireDefault(_beeModal);

var _beeDropdown = require('bee-dropdown');

var _beeDropdown2 = _interopRequireDefault(_beeDropdown);

var _beeMenus = require('bee-menus');

var _beeMenus2 = _interopRequireDefault(_beeMenus);

var _beeIcon = require('bee-icon');

var _beeIcon2 = _interopRequireDefault(_beeIcon);

var _protocolcheck = require('./protocolcheck');

var _print = require('./print');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Item = _beeMenus2["default"].Item;


var propTypes = {
    btns: _propTypes2["default"].array, //按钮的数据源
    containerId: _propTypes2["default"].string, //挂在的容器Id
    shape: _propTypes2["default"].string,
    colors: _propTypes2["default"].string,
    url: _propTypes2["default"].string
};

var defaultProps = {
    btns: [],
    clsPrefix: "ac-printing-button",
    shape: "border",
    colors: "primary"
};

//下载程序url
var _downloadUrl = "https://cdn.yonyoucloud.com/iprint/setup.exe?download";
//协议url
var _printCheckedUrl = "yonyou://iprint";

var AcPrintingButton = function (_Component) {
    _inherits(AcPrintingButton, _Component);

    function AcPrintingButton(props) {
        _classCallCheck(this, AcPrintingButton);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        _this.getMenusRender = function () {
            var _this$props = _this.props,
                btns = _this$props.btns,
                label = _this$props.label;

            var _btns = [];
            btns.map(function (btn, i) {
                var _btn = _react2["default"].createElement(
                    Item,
                    { key: i },
                    btn.icon ? _react2["default"].createElement(_beeIcon2["default"], { type: btn.icon }) : "",
                    btn.label
                );
                _btns.push(_btn);
            });

            var menu1 = _react2["default"].createElement(
                _beeMenus2["default"],
                { multiple: true, onClick: _this.onSelect },
                _btns
            );

            return _react2["default"].createElement(
                _beeDropdown2["default"],
                { trigger: ['click'], overlay: menu1,
                    animation: 'slide-up'
                },
                _react2["default"].createElement(
                    _beeButton2["default"],
                    { shape: 'border', colors: 'primary' },
                    label ? label : "操作"
                )
            );
        };

        _this.getBtnRender = function () {
            var _this$props2 = _this.props,
                shape = _this$props2.shape,
                colors = _this$props2.colors,
                btns = _this$props2.btns;

            var _btns = [];
            btns.map(function (btn) {
                var _btn = _react2["default"].createElement(
                    'div',
                    { className: 'ac-printing-cont' },
                    _react2["default"].createElement(
                        _beeButton2["default"],
                        { shape: btn.shape ? btn.shape : shape, colors: btn.colors ? btn.colors : colors,
                            onClick: function onClick() {
                                _this.btnOnClick(btn);
                            } },
                        btn.label
                    )
                );
                _btns.push(_btn);
            });
            return _btns;
        };

        _this.btnOnClick = function (data) {
            _this.getOpenUrl(data);
        };

        _this.onSelect = function (_ref) {
            var key = _ref.key;
            var btns = _this.props.btns;

            var data = btns[parseInt(key)];
            _this.getOpenUrl(data);
        };

        _this.getDesignUrl = function (url) {
            switch (url) {
                case "designTest":
                    return 'http://u8cprint.test.app.yyuap.com/u8cprint/design/getDesign';
                case "designDaily":
                    return 'https://u8cprint-daily.yyuap.com/u8cprint/design/getDesign';
                case "design":
                    return 'https://u8cprint.diwork.com/u8cprint/design/getDesign';
                case "previewTest":
                    return 'http://u8cprint.test.app.yyuap.com/u8cprint/design/getPreview';
                case "previewDaily":
                    return 'https://u8cprint-daily.yyuap.com/u8cprint/design/getPreview';
                case "preview":
                    return 'https://u8cprint.diwork.com/u8cprint/design/getPreview';
            }
        };

        _this.getParameter = function (data) {
            var _url = "",
                i = 1,
                newUrl = void 0;
            for (var key in data) {
                var element = data[key];
                if (element instanceof Object) {
                    return _this.getParameter(element);
                } else {
                    _url += key + "=" + element + "&";
                }
            }
            return _url;
        };

        _this.getOpenUrl = function (data) {
            var _url = "";var i = 1,
                newUrl = void 0;
            for (var key in data.urlParameter) {
                var element = data.urlParameter[key];
                if (element instanceof Object) {
                    _url += key + "=" + encodeURI(JSON.stringify(element)) + "&";
                } else {
                    _url += key + "=" + element + "&";
                }
            }
            console.log(" --data--", data);
            console.log(" --url--", _url);
            newUrl = (data.url ? _this.getDesignUrl(data.url) : url) + "?" + _url;
            if (data.type && data.type === "dowloand") {
                (0, _print.getOpen)(data, function (helpUrl) {
                    _this.setState({
                        showModal: true
                    }, function () {
                        window.open(helpUrl, '_blank');
                    });
                });
            } else {
                _this.openUrl(newUrl.substring(0, newUrl.length - 1));
            }
        };

        _this.openUrl = function (newUrl) {
            window.open(newUrl, '_blank').location;
        };

        _this.dowloandUrl = function () {
            var setupDownloadUrl = _this.props.setupDownloadUrl;

            window.open(setupDownloadUrl ? setupDownloadUrl : _downloadUrl);
            _this.close();
        };

        _this.close = function () {
            _this.setState({
                showModal: false
            });
        };

        _this.open = function (newUrl) {
            var showModal = false;
            _this.getProtocolCheck(newUrl).then(function (showModal) {
                // this.setState({
                //     showModal
                // });
                console.log(" showModal---- ", showModal);

                // this._time = setTimeout(() => {
                //     console.log(" --------------------33333333333333---- ");
                //     this.close();
                // }, 3000);
            });
        };

        _this.getProtocolCheck = function (newUrl) {
            var printCheckedUrl = _this.props.printCheckedUrl;

            return new Promise(function (resolve, reject) {
                (0, _protocolcheck.protocolCheck)((printCheckedUrl ? printCheckedUrl : _printCheckedUrl) + "?" + newUrl, function (succ) {
                    console.log(" --------------没有安装------失败---- ");
                    resolve(true);
                }, function (succ) {
                    console.log(" ---------------已安装-----成功---- ");
                    resolve(false);
                }, _this.props.parentContainerId);
            });
        };

        _this.state = {
            showModal: false
        };
        _this._time = null;
        return _this;
    }

    AcPrintingButton.prototype.componentDidMount = function componentDidMount() {
        var _props = this.props,
            layoutType = _props.layoutType,
            shape = _props.shape,
            colors = _props.colors,
            btns = _props.btns,
            containerId = _props.containerId;

        var compon = null;
        if (layoutType && layoutType === "menus") {
            compon = this.getMenusRender();
        } else {
            compon = this.getBtnRender();
        }
        _reactDom2["default"].render(compon, document.getElementById(containerId));
    };

    AcPrintingButton.prototype.componentWillUnmount = function componentWillUnmount() {
        this._time ? this._time = null : "";
    };

    // componentWillUnmount(){
    //     this._btns.forEach(btn => {
    //         // ReactDom.unmountComponentAtNode(btn);
    //         // document.body.removeChild(btn);
    //     });
    // }

    AcPrintingButton.prototype.render = function render() {
        var _props2 = this.props,
            clsPrefix = _props2.clsPrefix,
            shape = _props2.shape,
            colors = _props2.colors;
        // return <Modal show = { this.state.showModal }  onHide = { this.close }  width = '400'>
        //         <Modal.Header closeButton>
        //             <Modal.Title>温馨提示!</Modal.Title>
        //         </Modal.Header>
        //         <Modal.Body>
        //             <div className='ac-printing-btn-cont'>
        //                 <Button onClick={ this.dowloandUrl } shape="border" colors="primary">下载控件</Button>
        //             </div>
        //             <p className='ac-printing-tips'>如果您没下载控件请点击上方按钮，窗口将在3秒关闭。</p>
        //         </Modal.Body>
        //    </Modal>;

        return _react2["default"].createElement(
            _beeModal2["default"],
            { show: this.state.showModal, onHide: this.close, width: '400' },
            _react2["default"].createElement(
                _beeModal2["default"].Header,
                { closeButton: true },
                _react2["default"].createElement(
                    _beeModal2["default"].Title,
                    null,
                    '\u6E29\u99A8\u63D0\u793A!'
                )
            ),
            _react2["default"].createElement(
                _beeModal2["default"].Body,
                null,
                _react2["default"].createElement(
                    'p',
                    { className: 'ac-printing-tips' },
                    '\u76F4\u63A5\u6253\u5370\u63D2\u4EF6\u542F\u52A8\u5F02\u5E38\uFF0C\u5982\u9700\u5E2E\u52A9\u8BF7\u70B9\u51FB\u786E\u8BA4\uFF01'
                )
            )
        );
    };

    return AcPrintingButton;
}(_react.Component);

AcPrintingButton.propTypes = propTypes;
AcPrintingButton.defaultProps = defaultProps;
exports["default"] = AcPrintingButton;
module.exports = exports['default'];